
// JoyGen, v0.1, _ccos, Aug 2003

JoyAxis : UGen {
	*kr {
		arg minval=0, maxval=1, warp=0, lag=0.1, index=0, id=0;
		if (warp === \linear, { warp = 0 }, {
			if (warp === \exponential, { warp = 1 });
		});		
		^this.multiNew('control', id, index, minval, maxval, warp, lag);
	}
}

JoyButton : UGen {
	*kr {
		arg minval=0, maxval=1, lag=0.1, buttonMode=0, index=0, id=0;
		if( buttonMode === \normal, { buttonMode = 0 }, {
			if( buttonMode === \toggle, { buttonMode = 1 } );
		});
		^this.multiNew('control', id, index, minval, maxval, lag, buttonMode );
	}
}

JoyHat : UGen {
	*kr {
		arg hatVals, lag=0.1, buttonMode=0, index=0, id=0;
		hatVals = if( hatVals.isKindOf( ArrayedCollection ), {
			hatVals
		},{
			hatVals = hatVals ? { arg i; i };
			Array.fill( 9, hatVals );
		});
		if( buttonMode === \normal, { buttonMode = 0 }, {
			if( buttonMode === \toggle, { buttonMode = 1 } );
		});
		^this.multiNewList(['control', id, index] ++ hatVals ++ [lag, buttonMode]);
	}
}


/*
JoyAxis : UGen {
	*kr {
		arg minval=0, maxval=1, warp=0, lag=0.2, index=0, id=0;
		if (warp === \linear, { warp = 0 }, {
			if (warp === \exponential, { warp = 1 });
		});		
		^this.multiNew('control', id, index, minval, maxval, warp, lag);
	}
}

JoyButton : UGen {
	*kr {
		arg minval=0, maxval=1, lag=0.2, buttonMode=0, index=0, id=0;
		if( buttonMode === \normal, { buttonMode = 0 }, {
			if( buttonMode === \toggle, { buttonMode = 1 } );
		});
		^this.multiNew('control', id, index, minval, maxval, lag, buttonMode );
	}
}

JoyHat : UGen {
	*kr {
		arg posVals, lag=0.2, index=0, id=0;
		posVals ?? {Array.fill(9,{ arg i; i * 0.111111 })};
		^this.multiNewList(['control', id, index] ++ posVals ++ lag);
	}
}


*/

